Module SQL_LINE
    '=====LINE_權限代號 = "CC207" : 發送對象 = "tltony1234" : 通知變數X = "王詩文" : 通知變數Y = "9/7號" : LINE_通知模塊()=====
    Friend Sub SQL_LINE_使用者管理表_清單載入()
        ConnOpen_LINE_SQL()
        SQL1 = "SELECT    " & LINE_登入權限2 & " FROM 使用者權限管理表 RIGHT OUTER JOIN [HX-GPS-ERP-SYS].dbo.使用者權限管理表 AS 使用者權限管理表_1 ON 
                           使用者權限管理表.帳號 = 使用者權限管理表_1.帳號
                ORDER BY   使用者權限管理表_1.部門, 使用者權限管理表_1.職稱, 使用者權限管理表_1.課別, 使用者權限管理表_1.組別"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_LINE_使用者管理表_清單載入1()
        ConnOpen_LINE_SQL()
        SQL1 = "SELECT    " & LINE_登入權限2 & " FROM 使用者權限管理表 RIGHT OUTER JOIN [HX-GPS-ERP-SYS].dbo.使用者權限管理表 AS 使用者權限管理表_1 ON 
                           使用者權限管理表.帳號 = 使用者權限管理表_1.帳號
                WHERE      使用者權限管理表_1.部門 NOT LIKE '9%' 
                ORDER BY   使用者權限管理表_1.部門, 使用者權限管理表_1.職稱, 使用者權限管理表_1.課別, 使用者權限管理表_1.組別"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_LINE_通知設定表_清單載入()
        ConnOpen_LINE_SQL()
        SQL1 = "SELECT 姓名,通知語言,Line,WhatsApp,Message,token,電話號碼1,電話號碼2,電話號碼3 FROM 使用者權限管理表"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_LINE_使用者資料查詢()
        ConnOpen_LINE_SQL() : SQL1 = "SELECT * FROM 使用者權限管理表 WHERE (帳號 = '" & PA37 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_LINE_新增發送通知()
        ConnOpen_LINE_SQL()
        SQL1 = "INSERT INTO 通知設定表 (token,發送內容,隨機碼,通知語言,發送APP) VALUES (N'" & PA201 & "',N'" & PA202 & "',N'" & PA203 & "',N'" & PA204 & "',N'" & PA205 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_LINE_搜尋符合通知對象()
        ConnOpen_LINE_SQL()
        SQL1 = "SELECT  token,通知語言,電話號碼1,電話號碼2,電話號碼3,Line,WhatsApp,Message  FROM 使用者權限管理表 WHERE(" & LINE_權限代號 & "='True' and 姓名='" & 發送對象 & "')"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_LINE_通知內容清單載入()
        ConnOpen_LINE_SQL()
        SQL1 = "SELECT     通知內容設定表.權限代號, 權限一覽表.權限名稱, 通知內容設定表.通知內容, 通知內容設定表.通知格式, 
                           通知內容設定表.變數位置, 通知內容設定表.通知內容1, 通知內容設定表.通知內容2, 通知內容設定表.通知內容3, 
                           通知內容設定表.已使用
                FROM       通知內容設定表 INNER JOIN
                           權限一覽表 ON 通知內容設定表.權限代號 = 權限一覽表.權限代號
                ORDER BY   通知內容設定表.權限代號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_LINE_通知內容()
        ConnOpen_LINE_SQL()
        SQL1 = "SELECT  通知格式,變數位置,通知內容1,通知內容2,通知內容3  FROM 通知內容設定表 WHERE (權限代號='" & LINE_權限代號 & "')"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_LINE_權限清單載入()
        ConnOpen_LINE_SQL()
        SQL1 = "SELECT   權限一覽表.權限代號, 權限一覽表.權限名稱, 通知內容設定表.已使用
                FROM     權限一覽表 LEFT OUTER JOIN 通知內容設定表 ON 權限一覽表.權限代號 = 通知內容設定表.權限代號
                ORDER BY 權限一覽表.權限代號"
        CmdSet_For_DGV()
    End Sub
    Function SQL_LINE_隨機碼()
        Dim rancode As String
        Dim RndNum As New Random()
        rancode = Str(Date.Now.Year).Trim().PadLeft(4, "0") + Str(Date.Now.Month).Trim().PadLeft(2, "0") + Str(Date.Now.Day).Trim().PadLeft(2, "0") + Str(Date.Now.Hour).Trim().PadLeft(2, "0") + Str(Date.Now.Minute).Trim().PadLeft(2, "0") + Str(Date.Now.Second).Trim().PadLeft(2, "0") + Str(RndNum.Next(1000)).Trim().PadLeft(4, "0")
        Return rancode
    End Function
    Friend Sub LINE_通知模塊()
        Dim ds5, ds6 As New DataSet : ds5.Clear() : ds6.Clear()
        Dim 通知格式, 變數位置, 通知內容1, 通知內容2, 通知內容3, 發送X, 發送Y As String
        Dim L, M, W As Boolean
        SQL_LINE_搜尋符合通知對象()
        da.Fill(ds5) : LINE_使用者管理表.LINE_需通知清單_dgv.DataSource = ds5.Tables(0) : conn.Close()
        If 通知變數X = "" Then : 發送X = "未設定通知變數X" : Else : 發送X = 通知變數X : End If
        If 通知變數Y = "" Then : 發送Y = "未設定通知變數Y" : Else : 發送Y = 通知變數Y : End If
        For x As Integer = 0 To LINE_使用者管理表.LINE_需通知清單_dgv.Rows.Count - 1
            L = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells("Line").Value
            W = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells("WhatsApp").Value
            M = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells("Message").Value
            SQL_LINE_通知內容() : da.Fill(ds6) : LINE_使用者管理表.LINE_通知內容清單_dgv.DataSource = ds6.Tables(0) : conn.Close()
            If LINE_使用者管理表.LINE_需通知清單_dgv.Rows.Count = 0 Then : Else
                通知格式 = LINE_使用者管理表.LINE_通知內容清單_dgv.Rows(0).Cells(0).Value
                變數位置 = LINE_使用者管理表.LINE_通知內容清單_dgv.Rows(0).Cells(1).Value
                通知內容1 = LINE_使用者管理表.LINE_通知內容清單_dgv.Rows(0).Cells(2).Value
                通知內容2 = LINE_使用者管理表.LINE_通知內容清單_dgv.Rows(0).Cells(3).Value
                通知內容3 = LINE_使用者管理表.LINE_通知內容清單_dgv.Rows(0).Cells(4).Value
                If 變數位置 = "A" Then
                    PA202 = 通知內容1
                ElseIf 變數位置 = "X" Then
                    PA202 = 發送X
                ElseIf 變數位置 = "A+X" Then
                    PA202 = 通知內容1 + 發送X
                ElseIf 變數位置 = "X+A" Then
                    PA202 = 發送X + 通知內容1
                ElseIf 變數位置 = "X+A+Y" Then
                    PA202 = 發送X + 通知內容1 + 發送Y
                ElseIf 變數位置 = "A+X+B" Then
                    PA202 = 通知內容1 + 發送X + 通知內容2
                ElseIf 變數位置 = "X+A+Y+B" Then
                    PA202 = 發送X + 通知內容1 + 發送Y + 通知內容2
                ElseIf 變數位置 = "A+X+B+Y" Then
                    PA202 = 通知內容1 + 發送X + 通知內容2 + 發送Y
                ElseIf 變數位置 = "A+X+B+Y+C" Then
                    PA202 = 通知內容1 + 發送X + 通知內容2 + 發送Y + 通知內容3
                End If
                PA204 = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(1).Value
                If L = True Then
                    PA203 = SQL_LINE_隨機碼() : PA201 = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(0).Value.ToString : PA205 = "Line" : SQL_LINE_新增發送通知()
                End If
                If W = True Then
                    If LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(2).Value.ToString <> "" Then
                        PA203 = SQL_LINE_隨機碼() : PA201 = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(2).Value.ToString : PA205 = "WhatsApp" : SQL_LINE_新增發送通知()
                    End If
                    If LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(3).Value.ToString <> "" Then
                        PA203 = SQL_LINE_隨機碼() : PA201 = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(3).Value.ToString : PA205 = "WhatsApp" : SQL_LINE_新增發送通知()
                    End If
                    If LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(4).Value.ToString <> "" Then
                        PA203 = SQL_LINE_隨機碼() : PA201 = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(4).Value.ToString : PA205 = "WhatsApp" : SQL_LINE_新增發送通知()
                    End If
                End If
                If M = True Then
                    If LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(2).Value.ToString <> "" Then
                        PA203 = SQL_LINE_隨機碼() : PA201 = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(2).Value.ToString : PA205 = "Message" : SQL_LINE_新增發送通知()
                    End If
                    If LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(3).Value.ToString <> "" Then
                        PA203 = SQL_LINE_隨機碼() : PA201 = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(3).Value.ToString : PA205 = "Message" : SQL_LINE_新增發送通知()
                    End If
                    If LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(4).Value.ToString <> "" Then
                        PA203 = SQL_LINE_隨機碼() : PA201 = LINE_使用者管理表.LINE_需通知清單_dgv.Rows(x).Cells(4).Value.ToString : PA205 = "Message" : SQL_LINE_新增發送通知()
                    End If
                End If
            End If
        Next
        ds5.Clear() : ds6.Clear() : 通知變數X = "" : 通知變數Y = ""
    End Sub
End Module

